// SmartPtr.cpp : Defines the entry point for the console application.
//
#include "stdafx.h"
#include "smart_ptr.h"
#include <iostream>
#include <string>

int _tmain(int argc, _TCHAR* argv[])
{
	std::cout<<"Allocating first string:"<<std::endl;
	std::string	*s1 = new std::string("sample string s1");
	std::cout<<*s1<<std::endl;
	std::cout<<"Allocating first string:"<<std::endl;
	std::string *s2 = new std::string("sample string s2");
	std::cout<<*s2<<std::endl;
	std::cout<<"Creating 3 additional pointers for s1..."<<std::endl;
	std::string *ptr_to_s1_1 = s1;
	std::string *ptr_to_s1_2 = s1;
	std::string *ptr_to_s1_3 = s1;
	std::cout<<"Creating 2 additional pointers for s2..."<<std::endl;
	std::string *ptr_to_s2_1 = s2;
	std::string *ptr_to_s2_2 = s2;
	std::cout<<"Creating smart_ptr..."<<std::endl;
	smart_ptr<std::string> smart_ptr1(s1);
	smart_ptr<std::string> smart_ptr2(s2);
	smart_ptr<std::string> smart_ptr3(ptr_to_s1_1);
	smart_ptr<std::string> smart_ptr4(ptr_to_s1_2);
	smart_ptr<std::string> smart_ptr5(ptr_to_s1_3);
	smart_ptr<std::string> smart_ptr6(ptr_to_s2_1);
	smart_ptr<std::string> smart_ptr7(ptr_to_s2_2);
	std::cout<<"Total objects for s1: "<<smart_ptr1.counter()<<std::endl;
	std::cout<<"Total objects for s2: "<<smart_ptr2.counter()<<std::endl;
	std::cout<<"Calling rest pointer from smart_ptr (for s1): "<<*(smart_ptr3.get())<<std::endl;
	std::cout<<"Calling rest pointer from smart_ptr (for s2): "<<*(smart_ptr6.get())<<std::endl;
	std::cout<<"Done! You may be sure, that all objects will be deleted correctly..."<<std::endl;
	return 0;
}

